-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04525 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=4525;

create table RELEASES (
  RELEASE_ID bigint not null,
  OPTIMISTIC_LOCK_VERSION bigint not null,
  PRODUCT varchar(255) not null,
  VERSION varchar(255) not null,
  primary key (RELEASE_ID)
) engine=InnoDB;

create unique index IDX_UNIQUE_RELEASE on RELEASES
  (PRODUCT, VERSION);

alter table PARCELS
  add column RELEASE_ID bigint not null,
  add index IDX_PARCEL_RELEASE (RELEASE_ID),
  add constraint FK_PARCEL_RELEASE
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID);

create table CLUSTER_MANAGED_RELEASES (
  CLUSTER_ID bigint not null,
  RELEASE_ID bigint not null,
  primary key (CLUSTER_ID, RELEASE_ID)
) engine=InnoDB;

alter table CLUSTER_MANAGED_RELEASES
  add index IDX_CLSTR_MNGD_RLS_CLSTR (CLUSTER_ID),
  add constraint FK_CLSTR_MNGD_RLS_CLSTR
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);

alter table CLUSTER_MANAGED_RELEASES
  add index IDX_CLSTR_MNGD_RLS_RLS (RELEASE_ID),
  add constraint FK_CLSTR_MNGD_RLS_RLS
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID);

create table CLUSTER_ACTIVATED_RELEASES (
  CLUSTER_ID bigint not null,
  RELEASE_ID bigint not null,
  primary key (CLUSTER_ID, RELEASE_ID)
) engine=InnoDB;

alter table CLUSTER_ACTIVATED_RELEASES
  add index IDX_CLSTR_ACTV_RLS_CLSTR (CLUSTER_ID),
  add constraint FK_CLSTR_ACTV_RLS_CLSTR
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);

alter table CLUSTER_ACTIVATED_RELEASES
  add index IDX_CLSTR_ACTV_RLS_RLS (RELEASE_ID),
  add constraint FK_CLSTR_ACTV_RLS_RLS
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID);

